'use strict';

var ariaMocha = require('aria-mocha');

async function launchHeadless({hostname, port, path, watch}) {
  await ariaMocha.launch(createUrl({hostname, port, path}));
  !watch && process.exit();
}
const createUrl = ({port, hostname, path}) => `http://${hostname}:${port}/${path}`;
function viteTestPlugin(options) {
  let {dir = "tests", watch = false} = options || {};
  let port = 3e3;
  let hostname = "localhost";
  let indexPath = "node_modules/vite-plugin-test/index.html";
  const plugin = {
    name: "vite-plugin-test",
    configureServer(server) {
      var _a;
      server.middlewares.use("/test-files", async (_req, res, _next) => {
        const files = await ariaMocha.getTestFiles(`${dir}/**/*.spec.js`, true);
        res.writeHead(200, {
          "Content-type": "application/json"
        });
        res.end(JSON.stringify(files));
      });
      server.watcher.on("change", async (path, stats) => {
        await launchHeadless({hostname, port, watch, path: indexPath});
      });
      (_a = server.httpServer) == null ? void 0 : _a.on("listening", async () => {
        var _a2;
        const address = (_a2 = server.httpServer) == null ? void 0 : _a2.address();
        hostname = address.address === "::" ? "localhost" : address.address;
        port = address.port;
        await launchHeadless({hostname, port, watch, path: indexPath});
      });
    }
  };
  return plugin;
}

module.exports = viteTestPlugin;
